
function b62enc_(c)
{
	return "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz"[c];
}

function b62dec_(c)
{
	 return "\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\x00\x01\x02\x03\x04\x05\x06\x07\x08\x09\xff\xff\xff\xff\xff\xff\xff\x0a\x0b\x0c\x0d\x0e\x0f\x10\x11\x12\x13\x14\x15\x16\x17\x18\x19\x1a\x1b\x1c\x1d\x1e\x1f\x20\x21\x22\x23\xff\xff\xff\xff\xff\xff\x24\x25\x26\x27\x28\x29\x2a\x2b\x2c\x2d\x2e\x2f\x30\x31\x32\x33\x34\x35\x36\x37\x38\x39\x3a\x3b\x3c\x3d\xff\xff\xff\xff\xff".charCodeAt(c);
}

// u8a: Uint8Array
function base62_encode(u8a)
{
	var out = "";
	var pos = 0;
	var len = u8a.length
	var data = new uint64_t();
	while (pos < len) {
		var l = len - pos;
		if (l > 56) {
			l = 56;
		}
		out += b62enc_(l);
		for (var i = 0; i < l; i += 8) {
			data.clear();
			for (var j = 0; j < 8; j++) {
				var t = new uint64_t();
				t.lo = (i + j) < l ? u8a[pos + i + j] : 0;
				t.shl((j & 7) * 8);
				data.or_bigint(t);
			}
			for (var j = 0; j < 11; j++) {
				var m = data.div(62);
				out += b62enc_(m);
			}
		}
		pos += l;
	}
	return out;
}

// str: string
function base62_decode(str)
{
	var arr = [];
	var pos = 0;
	var len = str.length;
	var data = new uint64_t();
	while (pos < len) {
		var l = b62dec_(str.charCodeAt(pos) & 0x7f);
		if (l == 0xff) return null;
		if (l == 0) break;
		pos++;
		for (var i = 0; i < l; i += 8) {
			if (len < 11) return null;
			data.clear();
			for (var j = 0; j < 11; j++) {
				var n = b62dec_(str.charCodeAt(pos + 10 - j));
				if (n == 0xff) return null;
				data.mul(62);
				data.add(n);
			}
			var m = l - i;
			if (m > 8) {
				m = 8;
			}
			for (var j = 0; j < m; j++) {
				var t = data.clone();
				t.shr((j & 7) * 8);
				arr.push(t.lo & 0xff);
			
			}
			pos += 11;
		}
	}
	var out = new Uint8Array(arr.length);
	for (var i = 0; i < arr.length; i++) {
		out[i] = arr[i];
	}
	return out;
}
