
function uint(i)
{
	i &= 4294967295;
	if (i < 0) {
		i += 4294967296;
	}
	return i;
}

function uint64_t()
{
	this.hi = 0;
	this.lo = 0;

	this.clear = function ()
	{
		this.hi = 0;
		this.lo = 0;
	}

	this.add = function (x)
	{
		if (x < 0) {
			this.sub(-x);
			return;
		}
		this.lo += uint(x);
		this.hi = uint(this.hi + this.lo / 4294967296);
		this.lo = uint(this.lo & 4294967295);
	}
	
	this.sub = function (x)
	{
		if (x < 0) {
			this.add(-x);
			return;
		}
		x = uint(x);
		if (x <= this.lo) {
			this.lo = uint(this.lo - x);
		} else {
			this.lo += 4294967296 - x;
			if (this.hi > 0) {
				this.hi--;
			} else {
				this.hi = 4294967295;
			}
		}
	}
	
	this.mul = function (x)
	{
		x = uint(x);
		this.lo *= x;
		this.hi *= x;
		this.hi = uint(this.hi + this.lo / 4294967296);
		this.lo = uint(this.lo & 4294967295);
	}
	
	this.div = function (x)
	{
		x = uint(x);
		var m = this.hi % x;
		this.hi = uint(this.hi / x);
		this.lo = this.lo + m * 4294967296;
		var n = this.lo % x;
		this.lo = uint(this.lo / x);
		return n;
	}

	this.shl = function (x)
	{
		while (x > 0) {
			var n = x;
			if (n > 16) {
				n = 16;
			}
			var m = 1 << n;
			this.lo *= m;
			this.hi = uint(this.hi * m + uint(this.lo / 4294967296));
			this.lo = uint(this.lo);
			x -= n;
		}
	}

	this.shr = function (x)
	{
		while (x > 0) {
			var n = x;
			if (n > 16) {
				n = 16;
			}
			var m = (1 << n) - 1;
			var t = this.hi & m;
			this.lo = uint((this.lo >>> n) | (t << (32 - n)));
			this.hi = this.hi >>> n;
			x -= n;
		}
	}

	this.or_bigint = function (x)
	{
		this.lo = uint(this.lo | x.lo);
		this.hi = uint(this.hi | x.hi);
	}

	this.value = function ()
	{
		return this.hi * 4294967296 + this.lo;
	}

	this.clone = function ()
	{
		var t = new uint64_t();
		t.hi = this.hi;
		t.lo = this.lo;
		return t;
	}
}

