
function string_to_utf8_bytes(str)
{
	var arr = [];
	for (var i = 0; i < str.length; i++) {
		var c = str.charCodeAt(i);
		if (c < 0x80) {
			arr.push(c);
		} else if (c < 0x800) {
			arr.push((c >> 6) | 0xc0);
			arr.push((c & 0x3f) | 0x80);
		} else if (c < 0x10000) {
			arr.push((c >> 12) | 0xe0);
			arr.push(((c >> 6) & 0x3f) | 0x80);
			arr.push((c & 0x3f) | 0x80);
		} else if (c < 0x200000) {
			arr.push((c >> 18) | 0xf0);
			arr.push(((c >> 12) & 0x3f) | 0x80);
			arr.push(((c >> 8) & 0x3f) | 0x80);
			arr.push((c & 0x3f) | 0x80);
		} else if (c < 0x4000000) {
			arr.push((c >> 24) | 0xf8);
			arr.push(((c >> 18) & 0x3f) | 0x80);
			arr.push(((c >> 12) & 0x3f) | 0x80);
			arr.push(((c >> 8) & 0x3f) | 0x80);
			arr.push((c & 0x3f) | 0x80);
		} else {
			arr.push((c >> 30) | 0xfc);
			arr.push(((c >> 24) & 0x3f) | 0x80);
			arr.push(((c >> 18) & 0x3f) | 0x80);
			arr.push(((c >> 12) & 0x3f) | 0x80);
			arr.push(((c >> 8) & 0x3f) | 0x80);
			arr.push((c & 0x3f) | 0x80);
		}
	}
	var utf8 = new Uint8Array(arr.length);
	for (var i = 0; i < arr.length; i++) {
		utf8[i] = arr[i];
	}
	return utf8;
}


function utf8_bytes_to_string(utf8)
{
	var out = "";
	var state_a = 0;
	var state_b = 0;
	for (var i = 0; i < utf8.length; i++) {
		c = utf8[i];
		if (c & 0x80) {
			if (c & 0x40) {
				state_a = c;
				if (c & 0x20) {
					if (c & 0x10) {
						if (c & 0x08) {
							if (c & 0x04) {
								state_b = c & 0x01;
							} else {
								state_b = c & 0x03;
							}
						} else {
							state_b = c & 0x07;
						}
					} else {
						state_b = c & 0x0f;
					}
				} else {
					state_b = c & 0x1f;
				}
			} else {
				state_a <<= 1;
				state_b = (state_b << 6) | (c & 0x3f);
				if ((state_a & 0x40) == 0 && state_b >= 0x80 && state_b < 0x10000) {
					out += String.fromCharCode(state_b);
				}
			}
		} else {
			state_a = 0;
			state_b = 0;
			out += String.fromCharCode(c);
		}
	}
	return out;
}
